#ifndef __ENTER_PPC_SUPERVISOR_H__
#define __ENTER_PPC_SUPERVISOR_H__

#include <MacTypes.h>
#include <MixedMode.h>

#if TARGET_CPU_68K
typedef unsigned long float_reg_t[2];
#elif TARGET_CPU_PPC
typedef double float_reg_t;
#else
#error Unsupported CPU !
#endif

typedef struct PPCRegisterList
{
	unsigned long	PC;
	unsigned long	GPR[32];
	float_reg_t		FPR[32];
	
} PPCRegisterList;

// 68k entry point for PPC Call
typedef void (*EnterPriviledgedModeProc)(PPCRegisterList* regList);

// PPC procInfo
enum
{
	uppEnterPriviledgedModeProcInfo = kCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(PPCRegisterList*)))
};

// Normal entry point
extern void EnterPPCSupervisor(PPCRegisterList* regList);



#endif