#ifndef __DEBUG_TEXT_H__
#define __DEBUG_TEXT_H__

#ifndef __DEBUG_HAS_PRINTF__
#define __DEBUG_HAS_PRINTF__	1
#endif

typedef struct dt_context {
	/* pre-initialised */
	unsigned char*	base;
	unsigned long	row_bytes;	/* in bytes */
	unsigned long	depth;		/* 8, 16 or 32 */
	unsigned long	width;		/* in pixels */
	unsigned long	height;
	unsigned long	visible;
	
	/* initialised by dt_init() */
	unsigned long	siz_w, siz_h;
	unsigned long	pos_x, pos_y;
	
} dt_context ;

extern void dt_init(dt_context *ct);

extern void dt_draw_char(dt_context *ct, char c);
extern void dt_draw_string(dt_context *ct, char *s);
extern void dt_clear_screen(dt_context *ct);

#if __DEBUG_HAS_PRINTF__
extern int	dt_printf(dt_context *ct, const char * format, ...);
#endif

#endif